class House {
    public color: string;        // 家の色（どこからでもアクセス可能）
    private rooms: number;       // 部屋数（同じクラス内からのみアクセス可能）
    protected address: string;   // 住所（同じクラスおよび継承クラス内からのみアクセス可能）

    constructor(color: string, rooms: number, address: string) {
        this.color = color;
        this.rooms = rooms;
        this.address = address;
    }

    public displayColor(): void {
        console.log(`この家の色は${this.color}です。`);
    }

    private countRooms(): number {
        return this.rooms;
    }

    protected getAddress(): string {
        return this.address;
    }
}


const redHouse = new House("白",1,"東京都");   // House のインスタンス化

redHouse.color = "赤";
redHouse.displayColor();

// 以下はアクセス不可
//redHouse.rooms = 2;
//redHouse.countRooms();
//redHouse.address = "千葉県";
//redHouse.getAddress();